compete=function(n01,n02,tmax,r1,r2,k1,k2,alfa,beta)##duvida. pq temos o r nesta equao se procuramos o conceito de pop. constante
{
resulta=matrix(0, ncol=3, nrow=tmax)
resulta[,1]=0:(tmax-1)
resulta[1,c(2,3)]=c(n01,n02)
  for(t in 2:tmax)
  {
   nsp1=resulta[(t-1),2]
   nsp2=resulta[(t-1),3]
   resulta[t,2]=nsp1 + r1*nsp1*((k1-nsp1-alfa*nsp2)/k1)
   resulta[t,3]=nsp2 + r2*nsp2*((k2-nsp2-beta*nsp1)/k2)
     if (resulta[t,2]<1)  
     {
     resulta[t,2]=0
     }
     if (resulta[t,3]<1)  
     {
     resulta[t,3]=0
     }
  }

old=par(mfrow=c(1,2))
plot(resulta[,1],resulta[,2],ylim=c(0,max(na.omit(resulta[,2:3]))),type="l",lty=1,xlab="time (t)",ylab="Population size", main="Population Growth")
lines(resulta[,1],resulta[,3],lty=2)
plot(resulta[,2],resulta[,3],type="l",col="red",xlab="N1",ylab="N2",ylim=c(0,max(c(na.omit(resulta[,3]),k1/alfa,k2))),xlim=c(0,max(c(na.omit(resulta[,2]),k2/beta,k1))), main="Isoclines")
segments(0,k1/alfa,k1,0,lty=1)
segments(0,k2,k2/beta,0,lty=2)
legend("topright", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
return(resulta)
}

require("deSolve")

##Ex. 01
compete(n01=10, n02=10,r1=0.05, r2=0.03, k1=80, k2=50, alfa=1.2, beta=0.5, tmax=200)

##Sim. Neste caso especifico, hah coexistencia com equilibrio estavel. As duas especies nao
##devem explorar os recursos exatamente da mesma forma ou na mesma proporo. 

##Ex. 1)03
compete(n01=80, n02=30,r1=0.05, r2=0.03, k1=80, k2=50, alfa=1.2, beta=0.5, tmax=50)

##Sim porque, neste caso, as duas espcies atingem capacidades suportes inferiores ao que atingiriam
##na ausencia uma da outra. Nao hah crescimento de uma em direcao a sua capacidade suporte em detrimento do decaimento
##da outra. Olhando as isoclinas confirmamos a coexistencia com equilibrio estavel no ponto de cruzamento das isoclinas

##Ex.1)04
##O ponto de equilibrio estavel se assemelha em todos os casos independente do N0 utilizado. O que parece influenciar o ponto
##de convergencia das isoclinas sao as diferentes capacidades suportes e os valores alfa e beta, e no o tamanho da popualcao inicial.
##Os pontos de convergencia so sempre inferiores aos K de ambas as espcies.

##Ex:1)05 - usando os proprios exemplos dados no tutorial...
##Sp1 vence - beta>k2/k1 e alfa<k1/k2
compete(n01=10, n02=10,r1=0.05, r2=0.03, k1=80, k2=50, alfa=1.2, beta=0.7, tmax=750)

##Sp2 vence - beta>k2/k1 e alfa>k1/k2
compete(n01=10, n02=10,r1=0.05, r2=0.03, k1=80, k2=50, alfa=1.8, beta=0.5, tmax=750)

##Exclusao com equilibrio instavel- alfa>k1/k2 e beta>k2/k1
compete(n01=10, n02=10,r1=0.05, r2=0.03, k1=80, k2=50, alfa=2.5, beta=1.2, tmax=150)

##Ex.1)06
##Especies coexistem quando exploram os recursos da maneira e/ou instensidade diferentes.
##Quando diferentes condicoes ambientais favorecem uma ou outra especie em tempos diferentes
##controlando e permitindo a coexistencia e quando a competicao intra-especifica for mais 
##importante do que a competicao interespecifica.

##EX.02 - Crescimento continuo
cLVcomp=function(t,n,prts)
{
   with(as.list(prts),{
      dn1.dt= r1*n[1]*((k1-n[1]-alfa*n[2])/k1)
      dn2.dt= r2*n[2]*((k2-n[2]-beta*n[1])/k2)
      list(c(dn1.dt,dn2.dt))
   })  
}

library(deSolve)

##Sp 1 vence
prmts<-c(r1=0.05,r2=0.03,k1=80,k2=50,alfa=1.2, beta=0.7)
N0<-c(10,10)
res=ode(y=N0, times=seq(1,100,0.01), func=cLVcomp, parms=prmts)
matplot(res[,1],res[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,prmts[3]/prmts[5],prmts[3],0,lty=1)
segments(0,prmts[4],prmts[4]/prmts[6],0,lty=2)

##Sp2 vence
prmts<-c(r1=0.05,r2=0.03,k1=80,k2=50,alfa=2.2, beta=0.4)
N0<-c(10,10)
res=ode(y=N0, times=seq(1,100,0.01), func=cLVcomp, parms=prmts)
matplot(res[,1],res[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,prmts[3]/prmts[5],prmts[3],0,lty=1)
segments(0,prmts[4],prmts[4]/prmts[6],0,lty=2)

##Coexistencia estavel

prmts<-c(r1=0.05,r2=0.03,k1=80,k2=50,alfa=1.2, beta=0.35)
N0<-c(10,10)
res=ode(y=N0, times=seq(1,100,0.01), func=cLVcomp, parms=prmts)
matplot(res[,1],res[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,prmts[3]/prmts[5],prmts[3],0,lty=1)
segments(0,prmts[4],prmts[4]/prmts[6],0,lty=2)


##Coexistencia instavel
prmts<-c(r1=0.05,r2=0.03,k1=80,k2=50,alfa=2, beta=1)
N0<-c(10,10)
res=ode(y=N0, times=seq(1,100,0.01), func=cLVcomp, parms=prmts)
matplot(res[,1],res[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,prmts[3]/prmts[5],prmts[3],0,lty=1)
segments(0,prmts[4],prmts[4]/prmts[6],0,lty=2)

##Crescimento discreto
compete=function(n01,n02,tmax,r1,r2,k1,k2,alfa,beta) ##modifiquei a visualizacao grafica desta funcao, por isso colei novamente no ex.
{
   resulta=matrix(0, ncol=3, nrow=tmax)
   resulta[,1]=0:(tmax-1)
   resulta[1,c(2,3)]=c(n01,n02)
   for(t in 2:tmax)
   {
      nsp1=resulta[(t-1),2]
      nsp2=resulta[(t-1),3]
      resulta[t,2]=nsp1 + r1*nsp1*((k1-nsp1-alfa*nsp2)/k1)
      resulta[t,3]=nsp2 + r2*nsp2*((k2-nsp2-beta*nsp1)/k2)
      if (resulta[t,2]<1)  
      {
         resulta[t,2]=0
      }
      if (resulta[t,3]<1)  
      {
         resulta[t,3]=0
      }
   }
   old=par(mfrow=c(2,2))
   plot(resulta[,1],resulta[,2],ylim=c(0,max(na.omit(resulta[,2:3]))),type="l",lty=1,xlab="time (t)",ylab="Population size", main="Population Growth")
   lines(resulta[,1],resulta[,3],lty=2)
   plot(resulta[,2],resulta[,3],type="l",col="red",xlab="N1",ylab="N2",ylim=c(0,max(c(na.omit(resulta[,3]),k1/alfa,k2))),xlim=c(0,max(c(na.omit(resulta[,2]),k2/beta,k1))), main="Isoclines")
   segments(0,k1/alfa,k1,0,lty=1)
   segments(0,k2,k2/beta,0,lty=2)
   legend("topright", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
   return(resulta)
}

compete(n01=100, n02=10,r1=0.5, r2=0.3, k1=80, k2=50, alfa=1.2, beta=0.5, tmax=200)


##Crescimento continuo
pnovo=c(r1=0.5, r2=0.3, k1=80, k2=50, alfa=1.2, beta=0.5)
N0novo=c(100,10)
resu=ode(y=N0novo, times=seq(1,200,0.01), func=cLVcomp, parms=pnovo)
matplot(resu[,1],resu[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,pnovo[3]/pnovo[5],pnovo[3],0,lty=1)
segments(0,pnovo[4],pnovo[4]/pnovo[6],0,lty=2)

##No houve diferenca no ponto de convergencia entre populacoes com crescimento discreto e continuo
##com t=200

#testando com t=5

##Crescimento discreto
compete(n01=100, n02=10,r1=0.5, r2=0.3, k1=80, k2=50, alfa=1.2, beta=0.5, tmax=5)

##Crescimento continuo
pnovo=c(r1=0.5, r2=0.3, k1=80, k2=50, alfa=1.2, beta=0.5)
N0novo=c(100,10)
resu=ode(y=N0novo, times=seq(1,5,0.01), func=cLVcomp, parms=pnovo)
matplot(resu[,1],resu[,-1], type="l", ylab="Nmero de indivduos", xlab="tempo", main="Modelo de Competio\n Lotka-Volterra")
legend("topleft", legend=c("Specie 1", "Specie 2"), lty=c(1,2), bty="n", cex=0.8)
segments(0,pnovo[3]/pnovo[5],pnovo[3],0,lty=1)
segments(0,pnovo[4],pnovo[4]/pnovo[6],0,lty=2)

##Neste caso, a populacao apresenta coexistencia estavel no modelo de crescimento discreto,
##e exclusao da sp. 2 pela sp.1 no modelo de crescimento continuo. Isso pode ser explicado pelo
##tempo de retardo existente no modelo discreto e que permite que as sps. coexistam devido a mudancas 
##ambientais existentes nestes periodos. As especies conseguem explorar os recursos diferentemente a 
##cada geracao.

##Ex. 03
##Se 3 sps. passassem a competir entre si, uma terceira constante seria adicionada a equacao, medindo
##o efeito dos individuo desta especie sobre as demais, no que se refere a crescimento populacional.
##Seria algo como:
##nsp1 + r1*nsp1*((k1-nsp1-alfa*nsp2-gama*nsp3)/k1)
##nsp2 + r2*nsp2*((k2-nsp2-beta*nsp1-gama*nsp3)/k2)
##nsp3 + r3*nsp3*((k3-nsp3-beta*nsp1-alfa*nsp2)/k3)

##Ex.04
##alfa11 seria o efeito da denso-dependencia. Quanto maior K, menor o alfa? Ser isso??

##nsp1= r1*nsp1*(1- alfa11*N1-alfa21*N2)
##nsp2= r2*nsp2*(1- alfa22*N2-alfa12*N1)

##No  consigo responder estas questoes.

